/*
 * Operationen ueber Polynome
 * Implementation der Funktionen aus bruch.h
 */
# include "polynom.h"

int Grad = 0;
double *Polynom;

/* liest die Komponenten des Polynoms
 * in ein globales Feld double *Polynom;
 * und die Gre des Feldes in int Grad;
 */
void polynomEingabe()
{
  int i;
  do
  {
    printf( "Grad des Polynom? ");
    scanf( "%d", &i);
  } while( i < 0 && printf( "\nGrad > 0!\n"));

  Polynom =
    ( double*) malloc( sizeof( double) * ( Grad + 1));

  Grad = i;
  for( ; i >= 0; i--)
  {
    printf( " x^%d * ", i);
    scanf( "%lf", Polynom + i);
    if( i != 0) printf(" +\n");
  }
  
  return;
}


/*
 * berechnet den Funktionswert an der Stelle x
 * mittels Horner-Schema
 */
double polynom( double x)
{
  double Ergebnis = 0; int i;

  if ( !Grad)
  {
    printf( "Fehler: Polynom nicht eingelesen\n");
    exit( 1);
  }

  Ergebnis = Polynom[ 0];
  for( i = Grad; i >= 0; i--)
     Ergebnis = Ergebnis * x + Polynom[i];

  return Ergebnis;
}

/*
 * loescht das Polynom aus dem glabalen Feld
 * double *Polynom und setzt int Grad auf 0 zurueck
 */
void polynomLoeschen()
{
  free( Polynom); Grad = 0;
  return;
}
