/*
 * Fakultaet iterativ und rekursiv
 */

# include <stdio.h>
/*
 * Iterative Berechnung der Fakultaet n!
 * Eingabewert: n
 * Rueckgabewert: n!
 */
unsigned long itFak( int);

/*
 * Rekursive Berechnung der Fakultaet n!
 * Eingabewert: n
 * Rueckgabewert: n!
 */
unsigned long rekFak( int);

int main()
{
  int n;
  do
  {
    do
    {             /* 13! = 6'227'020'800 > ULONG_MAX */
      printf( "Fakultaetsberechnung\n");
      printf( "Eingabe n = (n <= 12, 0 fuer ENDE) ");
      scanf( "%d", &n);
    } while( n < 0 || n > 12);

    if( n == 0) break;

    printf( "%d! = %lu\n", n, itFak( n));
    printf( "%d! = %lu\n", n, rekFak( n));
  } while( 1);

  return 0;
}

/*
 * Fakultaet iterativ
 */
unsigned long itFak( int n)
{
  unsigned long fak = 1;
  for( ; n > 1; fak *= n--);
  return fak;
}

/*
 * Fakultaet rekursiv
 */
unsigned long rekFak( int n)
{
  if ( n) return n * rekFak( n - 1);
  return 1;
}

/*
   Fakultaetsberechnung ( n <= 12)
   Eingabe n = ( 0 fuer ENDE) 11
   11! = 39916800
   11! = 39916800

   Fakultaetsberechnung ( n <= 12)
   Eingabe n = ( 0 fuer ENDE) 12
   12! = 479001600
   12! = 479001600

   Fakultaetsberechnung ( n <= 12)
   Eingabe n = ( 0 fuer ENDE) 0

   12! =   479 001 600
   13! = 6 227 020 800
   ULONG_MAX = 4 294 967 295 ( 4 Byte) < 13!

   => Rechner 13! (Eingabeueberpruefung ausgeschaltet):
   Fakultaetsberechnung
   Eingabe n = ( 0 fuer ENDE) 13
   13! = 1932053504
   13! = 1932053504
*/