/*
 * Listenoperationen
 * Header fuer liste.c
 */

# ifndef _LISTE_H_
# define _LISTE_H_

struct kartes{ float x, y;};    /* kart. Koordinaten */
struct polar{ float rho, phi;};  /* Polarkoordinaten */

struct Punkt  /* Punkt in kart. und Polarkoordinaten */
{
  struct kartes kar;
  struct polar pol;
  struct Punkt *Nf;         /* Zeiger auf Nachfolger */
};

/*
 * Wandelt Polarkoordinaten in kartesische um
 * Parameter: struct polar  Punkt in Polarkoordinaten
 * Rueckgabe: struct kartes Punkt in kart. Koordinaten
 */
struct kartes kartesisch( struct polar);

/*
 * Sortiert, geordnet nach kart. Koordinaten,
 * in eine einfach verkettete Liste ein
 * Parameter: struct Punkt ** Anfangsadresse der Liste
 *            struct Punkt *  Punkt
 */
void sortier_ein( struct Punkt **, struct Punkt);

/*
 * Ausgabe eines Punktes
 */
void printPunkt( struct Punkt p);

/*
 * Ausgabe einer Liste
 */
void printListe( struct Punkt *);

/*
 * Punkt suchen
 */
struct Punkt *kar_suchen( struct Punkt*, struct Punkt);
struct Punkt *pol_suchen( struct Punkt*, struct Punkt);

/*
 * Punkt loeschen
 */
void kar_loeschen(struct Punkt **, struct Punkt);
void pol_loeschen(struct Punkt **, struct Punkt);

/*
 * Liste umkehren
 */
void inverse1( struct Punkt **);
void inverse2( struct Punkt **); 

/*
 * Hilfsfunktionen
 */
struct Punkt *haenge_ab( struct Punkt **);
void haenge_an( struct Punkt **, struct Punkt *);

# endif
