/*
 * Operationen in Listen von Strukturen
 */

# include <stdio.h>
# include "liste.h"

int main()         /* Anfangsadresse ist NULL-Zeiger */
{
  struct Punkt p, *Anfang = NULL, *a;

  printf( "Liste der Polarkoordinaten\n");
  printf( "[ 1, 0 Grad] - [ 1, 360 Grad]\n");
  printf( "im Abstand von 45 Grad\n");
  p.pol.rho = 1; p.pol.phi = 0;
  while( p.pol.phi <= 360)
  {
    p.kar = kartesisch( p.pol);
    sortier_ein( &Anfang, p);
    p.pol.phi += 45;
  }
  printListe( Anfang);

  printf( "Bitte die kartesischen Koordinaten\n"); 
  printf( "eines zu suchenden Punktes eingeben: ");
  scanf( "%f%f", &p.kar.x, &p.kar.y);
  a = kar_suchen( Anfang, p);

  if( a)
  {
    printf( "Der gesuchte Punkt hat die Koordinaten:\n");
    printPunkt( *a);
  }
  else printf( "Punkt nicht gefunden.\n");

  printf( "Bitte geben Sie die Polarkoordinaten\n");
  printf( "eines zu suchenden Punktes ein: ");
  scanf( "%f%f", &p.pol.rho, &p.pol.phi);
  a = pol_suchen( Anfang, p);

  if( a)
  {
    printf( "Der gesuchte Punkt hat die Koordinaten:\n");
    printPunkt( *a);
  }
  else printf( "Punkt nicht gefunden.\n");

  printf( "Bitte Polarkoordinaten des Punktes\n");
  printf( "eingeben, der gelscht werden soll: ");
  scanf( "%f%f", &p.pol.rho, &p.pol.phi);
  pol_loeschen( &Anfang, p);
  printListe( Anfang);

  printf( "Bitte die kartesischen Koordinaten des\n");
  printf( "Punktes eingeben, der gelscht werden soll: ");
  scanf( "%f%f", &p.kar.x, &p.kar.y);
  kar_loeschen( &Anfang, p);
  printListe( Anfang);

  inverse1(&Anfang);
  printf("invertiert:\n");
  printListe( Anfang);

  inverse2( &Anfang);
  printf( "Nochmals invertiert:\n");
  printListe( Anfang);

  return 0;
}

/*
   Liste sortiert (polar/kartesisch):
   (    1.000000,  180.000000)  (   -1.000000,   -0.000000)
   (    1.000000,  225.000000)  (   -0.707107,   -0.707107)
   (    1.000000,  135.000000)  (   -0.707107,    0.707107)
   (    1.000000,   90.000000)  (   -0.000000,    1.000000)
   (    1.000000,  270.000000)  (    0.000000,   -1.000000)
   (    1.000000,  315.000000)  (    0.707107,   -0.707107)
   (    1.000000,   45.000000)  (    0.707107,    0.707107)
   (    1.000000,    0.000000)  (    1.000000,    0.000000)
   (    1.000000,  360.000000)  (    1.000000,    0.000000)

   Bemerkung zu den Ergebnissen:
   Die kartesischen Koordinaten sind fehlerbehaftet
   (Rundungsfehler), d.h. in Funktionen, in denen die
   Suche nach Koordinaten enthalten ist, sollte man
   stets von den Polarkoordinaten ausgehen!
*/